'******************************************************************************'
'*                                                                            *'
'*      Universalzhler - Datenspeicherung im EE- Prom des ATTINY13           *'
'*                                                                            *'
'******************************************************************************'
'* S1 ist Eingang  fr Zhlimpulse                                            *'
'*                                                                            *'
'* S2 bertrgt die Daten zum PC                                              *'
'*                                                                            *'
'* Ein Stck Draht an  PinB.4 , optional ein Taster lst den RESET aus        *'
'*                                                                            *'
'*                                                                            *'
'******************************************************************************'
$regfile = "attiny13.dat"
$crystal = 1200000
$hwstack = 16
$swstack = 8
$framesize = 8

Open "comb.1:9600,8,n,1,INVERTED" For Output As #1
Config Pinb.0 = Input                                       'PB0 ist Eingang  "Schritte"
Portb.0 = 1                                                 'Pullup
Config Portb.1 = Output                                     'Led1
Portb.1 = 0                                                 'Led1 aus
Config Pinb.2 = Input                                       'PB2 ist Eingang "Anzeige"
Portb.2 = 1                                                 'Pullup
Config Pinb.4 = Input
Portb.4 = 1                                                 'Pullup
Config Portb.3 = Output                                     'Led2

Dim H As Byte
H = 0
Dim F As Byte                                               'Rechenvariable
F = 0

  Do                                                        'Endlos - Abfrage /Schritte
     Debounce Pinb.0 , 0 , Zaehlen , Sub
     Debounce Pinb.2 , 0 , Anzeigen , Sub                   'Anzeige
     Debounce Pinb.4 , 0 , Ruecksetzen , Sub                '***optional RESET***
  Loop                                                      '**Draht nach Masse**


End                                                         'Programmende

Zaehlen:                                                    'Subroutine "zaehlen"
 Incr F
 'H = F / 10                                                'Zhlbereich festlegen
 'H = F / 100
 H = F
 Writeeeprom H , 1                                          'H= Zhlwert, Speicherzelle
 Print #1 , H
 Return                                                     'Eingabekontrolle


Anzeigen:
 Readeeprom H , 1                                           'Subroutine "anzeigen"
 Print #1 , H
 Return


Ruecksetzen:                                                'Ausgangsbedingung herstellen
 F = 0
 Writeeeprom H , 1
 Portb.3 = 1
 Waitms 50
 Portb.3 = 0
 Waitms 50
 Portb.3 = 1
 Waitms 50
 Portb.3 = 0
 Waitms 50
 Portb.3 = 1
 Waitms 50
 Portb.3 = 0
 Waitms 50
 Return